<?php
/*
Plugin Name: VK Post Author Display
Plugin URI: http://demo.bizvektor.com/vkpostauthordisplay/
Description: Show post author information at post bottom.
Version: 0.1.2.0
Author: Vektor,Inc.
Author URI: http://vektor-inc.co.jp
License: GPL2

/*  Copyright 2013 Hidekazu Ishikawa ( email : kurudrive@gmail.com )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
	published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*-------------------------------------------*/

/*-------------------------------------------*/
/*	Display post author unit
/*-------------------------------------------*/
add_filter( 'the_content', 'pad_add_author');
function pad_add_author($content){
	if ( is_single()){
		if ( get_post_type() == 'post'){
			// twitter
			if (get_the_author_meta( pad_twitter, $author )){
				$twitter = '<span id="pad_twitter">Twitter:<a href="https://twitter.com/'.get_the_author_meta( pad_twitter, $author ).'" target
				="_blank">@'.get_the_author_meta( pad_twitter, $author ).'</a></span>';
			}
			// author caption
			if (get_the_author_meta( pad_caption, $author )){
				$caption = '<span id="pad_caption">'.get_the_author_meta( pad_caption, $author ).'</span>';
			}
			// author entries
			$autorID = $post->post_author;
			$loop = new WP_Query( array( 'post_type' => 'post', 'posts_per_page'=> 5, 'author' => $autorID ) );
			$entryList .= '<div id="latestEntries">'."\n";
			$entryList .= '<h5>Latest entries</h5>'."\n";
			$entryList .= '<ul class="entryList">'."\n";
			while ( $loop->have_posts() ) : $loop->the_post();
				$categories = '';
				foreach((get_the_category()) as $cat) {
					$cat_id = $cat->cat_ID ;
					break ;
				}
				$category_link = get_category_link( $cat_id );
				$categories = '<a href="'.$category_link.'" title="'.$cat->cat_name.'" class="padCate">'.$cat->cat_name.'</a>';
				$entryList .= '<li><span class="padDate">'.get_the_date('Y.m.d').'</span>'.$categories.'<a href="'.get_permalink($post->ID).'" class="padTitle">'.get_the_title().'</a></li>'."\n";
			endwhile;
			$entryList .= '</ul>'."\n";
			$entryList .= '</div>'."\n";

			//  get_author_posts_url()
			$author_unit =
				'<div id="padSection">'.
				'<h4>Author Profile</h4>'.
				'<div id="avatar">'.get_avatar( get_the_author_meta('email'), 80 ).'</div>'.
				'<dl id="profileTxtSet">'.
				'<dt>'.'<span id="authorName">'.get_the_author_meta( display_name, $author ).'</span>'.$caption.$twitter.'</dt>'.
				'<dd>'.nl2br(get_the_author_meta( description, $author )).'</dd>'.
				'</dl>'.
				$entryList.$autorID.
				'</div>';
			$content = $content.$author_unit;
		}
	}
	return $content;
}
/*-------------------------------------------*/
/*
/*-------------------------------------------*/
add_action('wp_head', 'pad_set_css');
function pad_set_css(){
	if ( get_post_type() == 'post'){
		wp_enqueue_style( 'set_vk_post_autor_css', plugins_url() . '/vk-post-author-display/css/vk-post-author.css' , false, '2013-02-05');
	}
}
/*-------------------------------------------*/
/*	Add user items
/*-------------------------------------------*/
function pad_update_profile_fields( $contactmethods ) {
	//項目の追加
	$contactmethods['pad_caption'] = 'Caption(Post Author Display)';
	$contactmethods['pad_twitter'] = 'Twitter(Post Author Display)';
	return $contactmethods;
}
add_filter('user_contactmethods','pad_update_profile_fields',10,1);

/*-------------------------------------------*/
/*	管理画面_admin_head JavaScriptのデバッグコンソールにhook_suffixの値を出力
/*-------------------------------------------*/

add_action("admin_head", 'suffix2console');
function suffix2console() {
    global $hook_suffix;
    if (is_user_logged_in()) {
        $str = "<script type=\"text/javascript\">console.log('%s')</script>";
        printf($str, $hook_suffix);
    }
}


/*-------------------------------------------*/
/*	Setting page
/*-------------------------------------------*/
// 第１引数で、どのページで適応するのかを指定。この場合後半（appearance_page_theme_u23）がどのページかを判断する hook_suffix になっている。
// hook_suffix は、body のclass名などから確認する事が出来る。
// 第２引数は処理するfunction名
// add_action( 'admin_print_styles-appearance_page_theme_u23', 'pad_custom_enqueue_scripts' );
// function pad_custom_enqueue_scripts( $hook_suffix ) {
// 	wp_enqueue_style( 'pad_plugin_options', get_template_directory_uri() . '/inc/theme-options.css', false, '2012-11-17' );
	/*　theme-options.csの設定は、現在(2012.11)は親テーマで読み込んでしまっているので実は記述不要。
		しかし、theme-options.cssは本来テーマオプションページでのみ効かせないといけない為、
		いずれBizVektor本体で修正するので、今後Post author display settingページでは theme-options.php を読みこまなくなる可能性があるので、
		こちらでも表記。
		※ちなみに wp_enqueue_style を経由しているので、タグは２重では出力されない。
	*/
// 	wp_enqueue_style( 'pad_plugin_options', get_stylesheet_directory_uri() . '/css/admin_theme-options.css', false, '2012-11-17' );
// }

function pad_get_default_options() {
	$display_author_options = array(
		'hide' => array(
			'value' => 'hide',
			'label' => 'hide',
		),
	);
}

function pad_plugin_options_Custom_init() {
	if ( false === pad_get_plugin_options() )
	add_option( 'pad_plugin_options', pad_get_default_options() );
	register_setting(
		'pad_plugin_options',
		'pad_plugin_options',
		'pad_plugin_options_validate'
	);
}
add_action( 'admin_init', 'pad_plugin_options_Custom_init' );

/*-------------------------------------------*/
/*	functionsで毎回呼び出して$options_padに入れる処理を他でする。
/*-------------------------------------------*/
function pad_get_plugin_options() {
	return get_option( 'pad_plugin_options', pad_get_default_options() );
}

/*-------------------------------------------*/
/*	メニューに追加
/*-------------------------------------------*/
function pad_add_customSetting() {
	$custom_page = add_options_page(
		'Post author display setting',		// Name of page
		'Post author display',		// Label in menu
		'edit_plugins',				// Capability required　このメニューページを閲覧・使用するために最低限必要なユーザーレベルまたはユーザーの種類と権限。
		'pad_plugin_options',				// ユニークなこのサブメニューページの識別子
		'pad_add_customSettingPage'			// メニューページのコンテンツを出力する関数
	);
	if ( ! $custom_page )
	return;
}
// add_action( 'admin_menu', 'pad_add_customSetting' );


/*-------------------------------------------*/
/*	編集画面
/*-------------------------------------------*/
function pad_add_customSettingPage() { ?>
<div class="wrap" id="pad_plugin_options">
<?php screen_icon(); ?>
<h2>Post author display setting</h2>

<form method="post" action="options.php">
<?php
	settings_fields( 'pad_plugin_options' );
	$options_pad = pad_get_plugin_options();
	$default_options = pad_get_default_options();
?>
<div id="" class="sectionBox">
<table class="form-table">
<tr>
<th>Display post author archive page</th>
<td>

<?php $author_archive_links = array('hide' => 'hide','display' => 'display author archive link');
foreach( $author_archive_links as $author_archive_link_value => $author_archive_link_lavel) { ?>
	<label>
	<?php if ( $author_archive_link_value == $options_pad['author_archive_link'] ) : $checked = ' checked'; endif; ?>
	<input type="radio" name="pad_plugin_options[author_archive_link]" value="<?php echo $author_archive_link_value ?>"<?php echo $checked; ?>> <?php echo $author_archive_link_lavel ?>
	</label>
<?php } ?>
</td>
</tr>
<tr>
<th>フッター右側ソーシャルアイコン用タグ <br />
[ <a href="<?php echo site_url(); ?>/wp-admin/media-new.php" target="_blank">→ 画像をアップロードする</a> ]</th>
<td><textarea cols="20" rows="10" name="pad_plugin_options[u23FootIconsTag]" id="u23FootIconsTag" value="" style="width:70%;" /><?php echo esc_attr( $options_pad['u23FootIconsTag'] ); ?></textarea><br />
</td>
</tr>
</table>
<?php submit_button(); ?>
</div><!-- [ /#sogoHeadBnr ] -->
</form>
</div>
<?php }

function pad_plugin_options_validate( $input ) {
	$output = $defaults = pad_get_default_options();

	$output['author_archive_link'] = $input['author_archive_link'];
	// ヘッダーバナー
	$output['u23FootIconsTag'] = $input['u23FootIconsTag'];

	return apply_filters( 'pad_plugin_options_validate', $output, $input, $defaults );
}

/*-------------------------------------------*/
/*	optionの値を単純に引っ張る
/*-------------------------------------------*/
function pad_options($optionLabel) {
	$options_pad = pad_get_plugin_options();
	if ($options_pad[$optionLabel]){
		return $options_pad[$optionLabel];
	}
}